#!/bin/bash

Maximallogcountage=3;	# how many logging days must remain until deletion

Host1="xytc001";	# host names that are pinged for existance
Host2="";
Host3="";

Signalfilename="testfile";
Signalfile="$Signalfilename";

PingLogger_init=1;	# counter for Pinging Hosts (in Seconds)
PSLogger_init=3;	# check for Processes after x seconds
Logremove_init=5;	# check for removable logs after x seconds

PSLogger=1;
PingLogger=1;
Logremove=1;

# rm -f RRLogPS.txt
# rm -f RRLogUsers.txt
# rm -f RRLogSignal.txt
# rm -f RRPing.txt

#logloop
while true; 
do
	
 Logdate=`date +%Y-%m-%d`;
 Logtime="LogTime: "`date +%Y-%m-%d" "%H-%M-%S`;
 Logpath="log_"$Logdate;
 cd ~
 mkdir -p $Logpath;
# Dircreation = `mkdir -p $Logpath`
# erg=`echo "$Dircreation" 2> $Logpath"/"errors.txt`
# #echo $erg

 LogWho=`who -u | grep -v -e "*" -e "root" -e "daemon"`;

if [ "$LogWho" != "" ]; then
 PSLogger=$(($PSLogger-1));
 PingLogger=$(($PingLogger-1)); 	
 Logremove=$(($Logremove-1));

#Signallogger
  LogSignal=`ps -ef | grep -v -e "*" -e "root" -e "daemon" -e "grep" | grep $Signalfilename`;
  Signal=`echo "$LogSignal"`
  if [ Signal != "" ]; then
   echo "$Logtime" >> "$Logpath"/"RRLogSignal.txt"
   echo "$LogSignal" >> "$Logpath"/"RRLogSignal.txt"
   stat "$Signalfile" >> "$Logpath"/"RRLogSignal.txt"
  fi

 if [ $Logremove == 0 ]; then
  Logremove=Logremove_init;
  anzDirs=`ls -d log_* | wc -w`;
  anzDirs=$(($anzDirs-$Maximallogcountage));
  for countage in `ls -d ~/log_*`; do

  if [ $anzDirs -gt 0 ]; then 
#   echo $anzDirs $countage; 
   anzDirs=$(($anzDirs-1));
   if [ $countage != "" ]; then
    echo "$countage wurde gelscht!"
    rm -rf $countage;   
   fi
  fi   
  done
 fi

#Pinglogger
 if [ $PingLogger == 0 ]; then
  PingLogger=PingLogger_init

  if [ "$Host1" != "" ]; then
#   pingstring=`echo ping -n -v -q -c 1 $Host1 2> "$Logpath/"pingerror.txt `
   pingstring=`echo ping -v -q -c 1 $Host1 2> "$Logpath/"pingerror.txt `
   pingerg=`echo "$pingstring"` 2> pingerror.txt
   pingerg=`cat $Logpath"/"pingerror.txt`
#  echo "$pingstring"
#  echo "$pingerg" 
   if [ pingerg != "" ]; then
    echo "$Logtime" >> $Logpath"/"RRPing.txt
    echo "$pingerg" >> $Logpath"/"RRPing.txt
   fi
  fi

  if [ "$Host2" != "" ]; then
   pingstring=`echo ping -n -v -q -c 1 $Host2 2> "$Logpath/"pingerror.txt `
#   pingstring=`ping -n -v -q -c 1 "$Host2" "$Logpath/"pingerror.txt`
   pingerg=`echo "$pingstring"`
   pingerg=`cat $Logpath"/"pingerror.txt`
   if [ pingerg != "" ]; then
    echo "$Logtime" >> $Logpath"/"RRPing.txt
    echo "$pingerg" >> $Logpath"/"RRPing.txt
   fi
  fi

  if [ "$Host3" != 0 ]; then
   pingstring=`echo ping -n -v -q -c 1 $Host2 2> "$Logpath/"pingerror.txt `
#   pingstring=`ping -n -v -q -c 1 "$Host3" 2>& "$Logpath/"pingerror.txt`
   pingerg=`echo "$pingstring"`
   pingerg=`cat $Logpath"/"pingerror.txt`
   if [ pingerg != "" ]; then
    echo "$Logtime" >> $Logpath"/"RRPing.txt
    echo "$pingerg" >> $Logpath"/"RRPing.txt
   fi
  fi
 fi

#PSLogger
  if [ $PSLogger == 0 ]; then
   PSLogger=PSLogger_init

   echo "\n\n$Logtime" >> $Logpath"/"RRLogUsers.txt
   echo "$LogWho" >> "$Logpath"/"RRLogUsers.txt"

    LogPS=`ps -ef | grep -v -e "*" -e "root" -e "daemon" -e "tcsh"`
    echo $Logtime >> $Logpath"/"RRLogPS.txt
    echo "$LogPS" >> $Logpath"/"RRLogPS.txt
  fi
 fi
 sleep 1
done
